/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo;

import java.util.ArrayList;
import java.util.Observable;
import javax.swing.JFrame;


/**
 * Clase GestorDocus, se encarga de <b>gestionar el documuento</b>
 * 
 */
public class GestorDocus extends Observable {

    /**
     * variable array donde guarda documentos requisitos
     */
    private ArrayList<DocumentoReq> mDocReq = new ArrayList();
    private JFrame auxJF;
    public GestorDocus() {
    }
    /**
     * Constructor de la clase
     */
    public GestorDocus(JFrame jf) {
        DocumentoReq doc = new DocumentoReq();
        mDocReq.add(doc);
        this.setDocReq(mDocReq);
        auxJF = jf;
    }

    /**
     * @return the mDocReq
     */
    public ArrayList<DocumentoReq> getDocReq() {
        return mDocReq;
    }

    /**
     * @param mDocReq the mDocReq to set
     */
    public void setDocReq(ArrayList<DocumentoReq> mDocReq) {
        this.mDocReq = mDocReq;
    }
    /**
     * Metodo para editar un documento
     * @param Id
     * @param Nombre
     * @param fecha
     * @param creador
     * @param preparado
     * @param comentario
     * @return devuelve un documento editado con los parametros pasados por referencia
     */
    public DocumentoReq editarDocu(int Id, String Nombre, String fecha, String creador, String preparado, String comentario) {

        //// Creo la instancia
        DocumentoReq auxDoc = new DocumentoReq();
        //// Asigno los valores a los atributos
        auxDoc.setId("DOCR");
        auxDoc.setId_n(Id);
        auxDoc.setIdent(auxDoc.getId()+String.valueOf(Id));
        auxDoc.setNombre(Nombre);
        auxDoc.setFecha(fecha);
        auxDoc.setCreador(creador);
        auxDoc.setPreparado(preparado);
        auxDoc.setComentario(comentario);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        
        this.getDocReq().remove(Id-1);
        this.getDocReq().add(auxDoc);
        return auxDoc;
    }

    /**
     * Metodo para insertar un documento
     * @param Id
     * @param Nombre
     * @param fecha
     * @param creador
     * @param preparado
     * @param comentario
     * @return devuelve un documento modificado con los parametros pasados por referencia
     */
    public DocumentoReq NuevoDocu(int Id, String Nombre, String fecha, String creador, String preparado, String comentario) {

        //// Creo la instancia
        DocumentoReq auxDoc = new DocumentoReq();
        //// Asigno los valores a los atributos
        auxDoc.setId("DOCR");
        auxDoc.setId_n(Id);
        auxDoc.setIdent(auxDoc.getId()+String.valueOf(Id));
        auxDoc.setNombre(Nombre);
        auxDoc.setFecha(fecha);
        auxDoc.setCreador(creador);
        auxDoc.setPreparado(preparado);
        auxDoc.setComentario(comentario);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        this.getDocReq().add(auxDoc);
        return auxDoc;
    }
}
