/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package vista;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * Filtro es la clase para crear el filtro del archivo para guardar la imagen en
 * el fichero gráfico.
 */
class FiltroImagenes extends FileFilter{

    /**
     * accept el metodo para aceptar filtroImagenes tanto de lectura como de escritura
     * @param f archivo a guardar o leer
     * @return si es o no aceptable el archivo
     */
    public boolean accept(File f){
        if (f.isDirectory()){
            return true;
        }
        String extension = f.getName();
        //podemos agregar mas extensiones
        if (extension.endsWith(".jpg")){
            return true;
        }
        if (extension.endsWith(".gif")){
            return true;
        }
        if (extension.endsWith(".bmp")){
            return true;
        }
        return false;
    }

    /**
     * Metodo que devuelve la descripcion del filtro
     * @return la descripcion del filtro
     */
    public String getDescription() {
        //es la descripcion que vemos
        return "Archivos de imágenes (.jpg,.gif,.bmp)";
    }
}
