/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmReqRestriccion.java
 *
 * Created on 13-dic-2011, 23:22:19
 */

package vista;

import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DocumentoReq;
import modelo.Objetivo;
import modelo.Subobjetivo;

/**
 * jfrmSubobjetivo es el formulario con el cual podremos insertar todas las variables del subobjetivo
 */
public class jfrmSubobjetivo extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    Subobjetivo newSubob;
    MutableTreeNode auxinsertNode;
    Objetivo auxOb;
    int auxinsertIndex;
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame Subobjetivo
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     * @param Ob es el objetivo que corresponde al subobjetivo
     */
    public jfrmSubobjetivo(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex, Objetivo Ob) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxOb = Ob;
        auxDocPpal=docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/subobjetivo.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxOb.getLIdentSO().size();
        i = auxOb.getSubobjetivo().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxOb.getLIdentSO().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="SUBO"+String.valueOf(i);
        jtxtId.setText(ident);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jlbNombre = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaSistema = new javax.swing.JTextArea();
        jtxtId = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jcbImportancia = new javax.swing.JComboBox();
        jcbUrgencia = new javax.swing.JComboBox();
        jcbEstado = new javax.swing.JComboBox();
        jcbEstabilidad = new javax.swing.JComboBox();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Subobjetivo");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbNombre.setText("Nombre");

        jLabel1.setText("El sistema deberá...");

        jtxaSistema.setColumns(20);
        jtxaSistema.setRows(5);
        jtxaSistema.setText("PD");
        jScrollPane1.setViewportView(jtxaSistema);

        jtxtId.setEditable(false);

        jLabel14.setText("Identificador:");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 395, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jlbNombre)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 226, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(18, Short.MAX_VALUE))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                .addGap(256, 256, 256))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbNombre)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 165, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("General", jPanel2);

        jLabel2.setText("Importancia");

        jLabel3.setText("Urgencia");

        jLabel4.setText("Estado de desarrollo");

        jLabel5.setText("Estabilidad");

        jcbImportancia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "vital", "importante" }));

        jcbUrgencia.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD ", "inmediata", "hay presión" }));

        jcbEstado.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "en construcción", "pendiente de verificación" }));

        jcbEstabilidad.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "PD", "baja ", "media" }));

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel5)
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jcbEstabilidad, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE)
                            .addComponent(jcbImportancia, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jcbUrgencia, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE)
                            .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jcbEstado, javax.swing.GroupLayout.Alignment.LEADING, 0, 386, Short.MAX_VALUE))
                        .addContainerGap(27, javax.swing.GroupLayout.PREFERRED_SIZE))))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbImportancia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbUrgencia, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jcbEstado, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jcbEstabilidad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(27, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Prioridad", jPanel4);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 438, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jbtnAceptar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jbtnCancelar)
                .addGap(248, 248, 248))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(41, Short.MAX_VALUE)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 285, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * editarPropiedades Método que edita las propiedades de un subobjetivo
     * @param SO subobjetivo para editar
     */
    void editarPropiedades(Subobjetivo SO) {
        editar = true;
        jtxtId.setText(SO.getIdent());
        jtxtNombre.setText(SO.getNombre());
        jtxaSistema.setText(SO.getDescripcion());
        jcbImportancia.setSelectedItem(SO.getImportancia());
        jcbUrgencia.setSelectedItem(SO.getUrgencia());
        jcbEstado.setSelectedItem(SO.getEstado());
        jcbEstabilidad.setSelectedItem(SO.getEstabilidad());
    }

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            int cont = auxOb.getLIdentSO().size();
            i = auxOb.getSubobjetivo().size();
            if (i == cont) {
                i = i + 1;
                auxOb.getLIdentSO().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxOb.getLIdentSO().get(l) == 0) {
                        i = l + 1;
                        auxOb.getLIdentSO().set(l, 1);
                    }
                }
            }
            newSubob = auxOb.nuevoSubObj(i, jtxtNombre.getText(), jtxaSistema.getText(), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString());
            MutableTreeNode node = new DefaultMutableTreeNode(newSubob.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Subobjetivo " + newSubob.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxOb.getSubobjetivo().size() && encontrado == false) {
                if (auxOb.getSubobjetivo().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxOb.getSubobjetivo().remove(i);
                    newSubob = auxOb.nuevoSubObj(j+1, jtxtNombre.getText(), jtxaSistema.getText(), jcbImportancia.getSelectedItem().toString(), jcbUrgencia.getSelectedItem().toString(), jcbEstado.getSelectedItem().toString(), jcbEstabilidad.getSelectedItem().toString());
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Subobjetivo " + newSubob.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmReqNoFuncional().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JComboBox jcbEstabilidad;
    private javax.swing.JComboBox jcbEstado;
    private javax.swing.JComboBox jcbImportancia;
    private javax.swing.JComboBox jcbUrgencia;
    private javax.swing.JLabel jlbNombre;
    private javax.swing.JTextArea jtxaSistema;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
        }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newSubob.getNombre()));
        jtxaSistema.setText(String.valueOf(newSubob.getDescripcion()));
        jcbImportancia.setSelectedItem(String.valueOf(newSubob.getImportancia()));
        jcbUrgencia.setSelectedItem(String.valueOf(newSubob.getUrgencia()));
        jcbEstado.setSelectedItem(String.valueOf(newSubob.getEstado()));
        jcbEstabilidad.setSelectedItem(String.valueOf(newSubob.getEstabilidad()));
    }
}
