/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmDatoEspecifico.java
 *
 * Created on 14-dic-2011, 16:11:43
 */

package vista;

import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DatoEspecifico;
import modelo.DocumentoReq;
import modelo.RequisitoInformacion;

/**
 * jfrmDatoEspecifico es el formulario con el cual podremos insertar todas las variables del dato especifico
 */
public class jfrmDatoEspecifico extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    RequisitoInformacion auxRI;
    jfrmPrincipal jfaux;
    MutableTreeNode auxinsertNode;
    DatoEspecifico auxDE;
    DatoEspecifico newDE;
    int auxinsertIndex;
    private int insertIndex;
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame DatoEspecifico
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     * @param RI es el requisito de informacion que corresponde con el dato especifico
     */
    public jfrmDatoEspecifico(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex, RequisitoInformacion RI) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        auxRI=RI;
        this.setIconImage(new ImageIcon("src/imagenes/datoEspecifico.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxRI.getLIdentDE().size();
        i = auxRI.getDatoEspecifico().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxRI.getLIdentDE().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="DAT"+String.valueOf(i);
        jtxtId.setText(ident);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabDatoEspecifico = new javax.swing.JTabbedPane();
        jpanDescripcion = new javax.swing.JPanel();
        jlbDescripcion = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaDescripcion = new javax.swing.JTextArea();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Dato especifico");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbDescripcion.setText("Descripción");

        jtxaDescripcion.setColumns(20);
        jtxaDescripcion.setRows(5);
        jtxaDescripcion.setText("PD");
        jScrollPane1.setViewportView(jtxaDescripcion);

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jpanDescripcionLayout = new javax.swing.GroupLayout(jpanDescripcion);
        jpanDescripcion.setLayout(jpanDescripcionLayout);
        jpanDescripcionLayout.setHorizontalGroup(
            jpanDescripcionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanDescripcionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanDescripcionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanDescripcionLayout.createSequentialGroup()
                        .addGroup(jpanDescripcionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 310, Short.MAX_VALUE)
                            .addComponent(jlbDescripcion))
                        .addContainerGap())
                    .addGroup(jpanDescripcionLayout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(153, 153, 153))))
        );
        jpanDescripcionLayout.setVerticalGroup(
            jpanDescripcionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jpanDescripcionLayout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(jpanDescripcionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jlbDescripcion)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jTabDatoEspecifico.addTab("Descripción", jpanDescripcion);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabDatoEspecifico, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(15, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabDatoEspecifico, javax.swing.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnAceptar)
                        .addGap(18, 18, 18)
                        .addComponent(jbtnCancelar)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * editarPropiedades Método que edita las propiedades de un dato especifico
     * @param dato dato para editar
     */
    public void editarPropiedades(DatoEspecifico dato) {
        editar = true;
        auxDE = dato;
        jtxtId.setText(dato.getIdent());
        jtxaDescripcion.setText(dato.getDescripcion());
    }

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            int cont = auxRI.getLIdentDE().size();
            i = auxRI.getDatoEspecifico().size();
            if (i == cont) {
                i = i + 1;
                auxRI.getLIdentDE().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxRI.getLIdentDE().get(l) == 0) {
                        i = l + 1;
                        auxRI.getLIdentDE().set(l, 1);
                    }
                }
            }
            newDE = auxRI.nuevoDato(i, jtxaDescripcion.getText());
            MutableTreeNode node = new DefaultMutableTreeNode(newDE.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado nuevo Dato Especifico");
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxRI.getDatoEspecifico().size() && encontrado == false) {
                if (auxRI.getDatoEspecifico().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxRI.getDatoEspecifico().remove(i);
                    newDE = auxRI.nuevoDato(j + 1, jtxaDescripcion.getText());
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado nuevo Dato Especifico");
            jfaux.setEnabled(true);
            this.dispose();
        }
}//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmDatoEspecifico().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel12;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabDatoEspecifico;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JLabel jlbDescripcion;
    private javax.swing.JPanel jpanDescripcion;
    private javax.swing.JTextArea jtxaDescripcion;
    private javax.swing.JTextField jtxtId;
    // End of variables declaration//GEN-END:variables
   
    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
        JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
    }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxaDescripcion.setText(String.valueOf(newDE.getDescripcion()));
    }
}
