/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmFicheroGrafico.java
 *
 * Created on 18-ene-2012, 12:12:29
 */

package vista;

import java.io.File;
import javax.swing.JFileChooser;
import modelo.FicheroGrafico;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DocumentoReq;

/**
 * jfrmFicheroGrafico es el formulario con el cual podremos insertar todas las variables del fichero grafico
 */
public class jfrmFicheroGrafico extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    FicheroGrafico newFich;
    FiltroImagenes filtroImagenes = new FiltroImagenes();
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    File fichero;
    private boolean editar= false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame FicheroGrafico
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     */
    public jfrmFicheroGrafico(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/ficherografico.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxDocPpal.getLIdentFI().size();
        i = auxDocPpal.getFicheroGrafico().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxDocPpal.getLIdentFI().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="FICH"+String.valueOf(i);
        jtxtId.setText(ident);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jlbNombre = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jftxtFichero = new javax.swing.JFormattedTextField();
        jbExaminar = new javax.swing.JButton();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaComentarios = new javax.swing.JTextArea();
        jlbComentarios = new javax.swing.JLabel();
        jbAceptar = new javax.swing.JButton();
        jbCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Fichero gráfico");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbNombre.setText("Nombre");

        jLabel1.setText("Fichero");

        jbExaminar.setText("Examinar");
        jbExaminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbExaminarActionPerformed(evt);
            }
        });

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(200, 200, 200))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jlbNombre)
                            .addComponent(jLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jftxtFichero, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                            .addComponent(jtxtNombre, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addComponent(jbExaminar)
                        .addContainerGap())))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbNombre)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jftxtFichero, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbExaminar))
                .addContainerGap(73, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("General", jPanel2);

        jtxaComentarios.setColumns(20);
        jtxaComentarios.setRows(5);
        jtxaComentarios.setText("Ninguno");
        jScrollPane1.setViewportView(jtxaComentarios);

        jlbComentarios.setText("Comentarios");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 349, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbComentarios))
                .addContainerGap(18, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jlbComentarios)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 152, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Comentarios", jPanel4);

        jbAceptar.setText("Aceptar");
        jbAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbAceptarActionPerformed(evt);
            }
        });

        jbCancelar.setText("Cancelar");
        jbCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 382, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jbAceptar, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbAceptar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbCancelar))
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 223, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbExaminarActionPerformed Activa el boton examinar
     * @param evt
     */
    private void jbExaminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbExaminarActionPerformed
//se crea el fileChooser
        JFileChooser fileChooser = new JFileChooser();
//se añade el filtro
        fileChooser.setFileFilter(filtroImagenes);
//titulo de la ventana
        fileChooser.setDialogTitle("Titulo de la ventana");
//se crea un nuevo file donde se especifica la ruta de destino
        File ruta = new File("Ruta de destino");
//coloca la ruta donde se abrira el fileChooser
        fileChooser.setCurrentDirectory(ruta);
        int result = fileChooser.showOpenDialog(null);
        if (result == JFileChooser.APPROVE_OPTION) {
            fichero = fileChooser.getSelectedFile();
            jftxtFichero.setText(String.valueOf(fichero));
        }
}//GEN-LAST:event_jbExaminarActionPerformed
    
    /**
     * editarPropiedades Método que edita las propiedades de un fichero grafico
     * @param Fic es el fichero grafico para editar
     */
    void editarPropiedades(FicheroGrafico Fic) {
        editar = true;
        jtxtId.setText(Fic.getIdent());
        jtxtNombre.setText(Fic.getNombre());
        if (Fic.getFichero() != null) {
            jftxtFichero.setText(Fic.getFichero().toString());
        }
        jtxaComentarios.setText(Fic.getComentarios());
    }

    /**
     * jbAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            int cont = auxDocPpal.getLIdentFI().size();
            i = auxDocPpal.getFicheroGrafico().size();
            if (i == cont) {
                i = i + 1;
                auxDocPpal.getLIdentFI().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxDocPpal.getLIdentFI().get(l) == 0) {
                        i = l + 1;
                        auxDocPpal.getLIdentFI().set(l, 1);
                    }
                }
            }
            newFich = auxDocPpal.nuevoFichero(i, jtxtNombre.getText(), fichero, jtxaComentarios.getText());
            MutableTreeNode node = new DefaultMutableTreeNode(newFich.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado la imagen " + newFich.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getFicheroGrafico().size() && encontrado == false) {
                if (auxDocPpal.getFicheroGrafico().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxDocPpal.getFicheroGrafico().remove(i);
                    newFich = auxDocPpal.nuevoFichero(j+1, jtxtNombre.getText(), fichero, jtxaComentarios.getText());
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado la imagen " + newFich.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbAceptarActionPerformed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmFicheroGrafico().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbAceptar;
    private javax.swing.JButton jbCancelar;
    private javax.swing.JButton jbExaminar;
    private javax.swing.JFormattedTextField jftxtFichero;
    private javax.swing.JLabel jlbComentarios;
    private javax.swing.JLabel jlbNombre;
    private javax.swing.JTextArea jtxaComentarios;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
        }

 /**
  * update Método que es llamado cuando el objeto observado cambia
  * @param o objeto observable
  * @param arg argumento pasado al método notifyObservers
  */
 public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newFich.getNombre()));
        jtxaComentarios.setText(String.valueOf(newFich.getComentarios()));
        jftxtFichero.setText(String.valueOf(newFich.getFichero()));
    }
}
