/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmMatrizRastreabilidad.java
 *
 * Created on 14-ene-2012, 23:39:54
 */

package vista;

import java.util.Observable;
import java.util.Observer;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DocumentoReq;
import modelo.MatrizRastreabilidad;

/**
 * jfrmMatrizRastreabilidad es el formulario con el cual podremos insertar todas las variables de la matriz de rastreabilidad
 */
public class jfrmMatrizRastreabilidad extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    String auxFila = "";
    String auxColumna = "";
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    int insertIndex;
    MatrizRastreabilidad newMatriz;
    MatrizRastreabilidad auxMa;
    DefaultListModel listModelF = new DefaultListModel();
    DefaultListModel listModelC = new DefaultListModel();
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame MatrizRastreabilidad
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     */
    public jfrmMatrizRastreabilidad(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/matrizRastr.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxDocPpal.getLIdentMR().size();
        i = auxDocPpal.getMatrizRastreabilidad().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxDocPpal.getLIdentMR().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="MAT"+String.valueOf(i);
        jtxtId.setText(ident);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jbtnCancelar = new javax.swing.JButton();
        jbtnAceptar = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jbtnAnadirF = new javax.swing.JButton();
        jbtnAnadirC = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jlstFilas = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        jlstColumnas = new javax.swing.JList();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaComentario = new javax.swing.JTextArea();
        jLabel4 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Matriz Rastreabilidad");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jLabel1.setText("Nombre");

        jLabel2.setText("Fila de la matriz");

        jLabel3.setText("Columna de la matriz");

        jbtnAnadirF.setText("Añadir Filas");
        jbtnAnadirF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAnadirFActionPerformed(evt);
            }
        });

        jbtnAnadirC.setText("Añadir Columnas");
        jbtnAnadirC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAnadirCActionPerformed(evt);
            }
        });

        jlstFilas.addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
                jlstFilasAncestorAdded(evt);
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
            }
        });
        jScrollPane2.setViewportView(jlstFilas);

        jlstColumnas.addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
                jlstColumnasAncestorAdded(evt);
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
            }
        });
        jScrollPane3.setViewportView(jlstColumnas);

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 65, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(jtxtId, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 92, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 115, Short.MAX_VALUE))
                            .add(jLabel1)
                            .add(jtxtNombre, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(208, 208, 208)))
                        .add(97, 97, 97))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jScrollPane2, 0, 0, Short.MAX_VALUE)
                            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 202, Short.MAX_VALUE)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(103, 103, 103)))
                        .add(40, 40, 40)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jbtnAnadirF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jbtnAnadirC))
                        .add(24, 24, 24))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap(15, Short.MAX_VALUE)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE, false)
                    .add(jtxtId, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel12))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jtxtNombre, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 73, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(24, 24, 24)
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 73, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(52, 52, 52)
                        .add(jbtnAnadirF)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 102, Short.MAX_VALUE)
                        .add(jbtnAnadirC)
                        .add(37, 37, 37))))
        );

        jTabbedPane1.addTab("General", jPanel1);

        jtxaComentario.setColumns(20);
        jtxaComentario.setRows(5);
        jScrollPane1.setViewportView(jtxaComentario);

        jLabel4.setText("Comentarios:");

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(21, 21, 21)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 327, Short.MAX_VALUE)
                    .add(jLabel4))
                .add(41, 41, 41))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(33, 33, 33)
                .add(jLabel4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 208, Short.MAX_VALUE)
                .add(57, 57, 57))
        );

        jTabbedPane1.addTab("Comentarios", jPanel2);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 394, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jbtnAceptar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 75, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jbtnCancelar))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 346, Short.MAX_VALUE)
                .add(21, 21, 21))
            .add(layout.createSequentialGroup()
                .add(19, 19, 19)
                .add(jbtnAceptar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jbtnCancelar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(302, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
}//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * editarPropiedades Método que edita las propiedades de la matriz de rastreabilidad
     * @param MR matriz de rastreabilidad para editar
     */
     void editarPropiedades(MatrizRastreabilidad MR) {
        editar = true;
        jtxtId.setText(MR.getIdent());
        jtxtNombre.setText(MR.getNombre());
        jtxaComentario.setText(MR.getComentarios());
        if (!MR.getFila().equals("No Data Model")) {
            listModelF.addElement(MR.getFila());
            jlstFilas.setModel(listModelF);
        }
        if (!MR.getColumna().equals("No Data Model")) {
            listModelC.addElement(MR.getColumna());
            jlstColumnas.setModel(listModelC);
        }
    }

     /**
      * jbtnAceptarActionPerformed Activa el boton aceptar
      * @param evt
      */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0;
        ident=jtxtId.getText();
        int cont3 = jlstFilas.getModel().getSize();
        int cont4 = jlstColumnas.getModel().getSize();
        if (jlstFilas.getModel().getSize() == 1) {
            auxFila = (jlstFilas.getModel().getElementAt(cont3-1).toString());
        }
        if (jlstColumnas.getModel().getSize() == 1) {
            auxColumna = jlstColumnas.getModel().getElementAt(cont4-1).toString();
        }
        int l=0;
        if (!editar) {
            int cont = auxDocPpal.getLIdentMR().size();
            i = auxDocPpal.getMatrizRastreabilidad().size();
            if (i == cont) {
                i = i + 1;
                auxDocPpal.getLIdentMR().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxDocPpal.getLIdentMR().get(l) == 0) {
                        i = l + 1;
                        auxDocPpal.getLIdentMR().set(l, 1);
                    }
                }
            }
            newMatriz = auxDocPpal.nuevaMatriz(i, jtxtNombre.getText(), auxFila, auxColumna, jtxaComentario.getText());
            MutableTreeNode node = new DefaultMutableTreeNode(newMatriz.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertada la Matriz " + newMatriz.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getMatrizRastreabilidad().size() && encontrado == false) {
                if (auxDocPpal.getMatrizRastreabilidad().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxDocPpal.getMatrizRastreabilidad().remove(i);
                    newMatriz = auxDocPpal.nuevaMatriz(j+1, jtxtNombre.getText(), auxFila, auxColumna, jtxaComentario.getText());
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertada la Matriz " + newMatriz.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
}//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnAnadirFActionPerformed Activa el boton añadir filas
     * @param evt
     */
    private void jbtnAnadirFActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAnadirFActionPerformed
        jfrmAnadirF jfAF = new jfrmAnadirF(this, auxDocPpal, jlstFilas);
        jfAF.setVisible(true);
        this.setEnabled(false);
}//GEN-LAST:event_jbtnAnadirFActionPerformed

    /**
     * jbtnAnadirCActionPerformed Activa el boton añadir columnas
     * @param evt
     */
    private void jbtnAnadirCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAnadirCActionPerformed
        jfrmAnadirC jfAC = new jfrmAnadirC(this, auxDocPpal, jlstColumnas);
        jfAC.setVisible(true);
        this.setEnabled(false);
    }//GEN-LAST:event_jbtnAnadirCActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * jlstFilasAncestorAdded Activa el list filas
     * @param evt
     */
    private void jlstFilasAncestorAdded(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_jlstFilasAncestorAdded
        jbtnAnadirF.setEnabled(true);
    }//GEN-LAST:event_jlstFilasAncestorAdded

    /**
     * jlstColumnasAncestorAdded Activa el list columnas
     * @param evt
     */
    private void jlstColumnasAncestorAdded(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_jlstColumnasAncestorAdded
        jbtnAnadirC.setEnabled(true);
    }//GEN-LAST:event_jlstColumnasAncestorAdded

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmMatrizRastreabilidad().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnAnadirC;
    private javax.swing.JButton jbtnAnadirF;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JList jlstColumnas;
    private javax.swing.JList jlstFilas;
    private javax.swing.JTextArea jtxaComentario;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtNombre;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
        }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newMatriz.getNombre()));
        //auxlFila;
    }
}
