/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmPaso.java
 *
 * Created on 23-nov-2011, 17:38:10
 */
package vista;

import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.CasodeUso;
import modelo.DocumentoReq;
import modelo.ExcepcionCU;
import modelo.PasoCU;



/**
 * jfrmPaso es el formulario con el cual podremos insertar todas las variables del paso de un caso de uso
 */
public class jfrmPaso extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    CasodeUso auxCaso;
    jfrmPrincipal jfaux;
    PasoCU newPaso;
    ArrayList <ExcepcionCU> auxEx = new ArrayList();
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    boolean editar = false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame Paso
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     * @param CU el caso de uso
     */
    public jfrmPaso(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex, CasodeUso CU) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        auxCaso = CU;
        this.setIconImage(new ImageIcon("src/imagenes/paso.jpg").getImage());
        initComponents();
        jgrpbtnTipoAccion.add(jrbtnAccionSistema);
        jgrpbtnTipoAccion.add(jrbtnAccionActor);
        jgrpbtnTipoAccion.add(jrbtnInclusionExtension);
        jrbtnAccionSistema.setSelected(true);
        jrbtnAccionActor.setEnabled(false);
        jrbtnInclusionExtension.setEnabled(false);
        jtxaCondicion.setEnabled(false);
        int l = 0, i=0;
        int cont = auxCaso.getLIdentPS().size();
        i = auxCaso.getPasoCU().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxCaso.getLIdentPS().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="PCU"+String.valueOf(i)+". "+auxCaso.getIdent();
        jtxtId.setText(ident);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jgrpbtnTipoAccion = new javax.swing.ButtonGroup();
        jtabComentarios = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jcbcondicional = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaCondicion = new javax.swing.JTextArea();
        jLabel12 = new javax.swing.JLabel();
        jtxtId = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jrbtnAccionSistema = new javax.swing.JRadioButton();
        jrbtnAccionActor = new javax.swing.JRadioButton();
        jrbtnInclusionExtension = new javax.swing.JRadioButton();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jtxaAccion = new javax.swing.JTextArea();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jtxtValor = new javax.swing.JTextField();
        jtxtActor = new javax.swing.JTextField();
        jtxtIE = new javax.swing.JTextField();
        jtxtUnidad = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtxaComentarios = new javax.swing.JTextArea();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Nuevo Paso");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jLabel1.setText("Tipo de paso");

        jcbcondicional.setText("Este paso es condicional");

        jLabel2.setText("Condición");

        jtxaCondicion.setColumns(20);
        jtxaCondicion.setRows(5);
        jtxaCondicion.setText("PD\n");
        jScrollPane1.setViewportView(jtxaCondicion);

        jLabel12.setText("Identificador:");

        jtxtId.setEditable(false);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jcbcondicional)
                            .addComponent(jLabel2)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 322, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(42, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(197, 197, 197))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jcbcondicional)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jtabComentarios.addTab("Condición", jPanel1);

        jLabel4.setText("Tipo de acción");

        jrbtnAccionSistema.setSelected(true);
        jrbtnAccionSistema.setText("Accción del sistema");

        jrbtnAccionActor.setText("Acción de un actor");

        jrbtnInclusionExtension.setText("Inclusión/extensión");

        jLabel5.setText("Acción(es) realizada(s) por el sistema/un actor");

        jtxaAccion.setColumns(20);
        jtxaAccion.setRows(5);
        jtxaAccion.setText("PD\n");
        jScrollPane3.setViewportView(jtxaAccion);

        jLabel6.setText("Rendimiento");

        jLabel7.setText("Valor");

        jLabel8.setText("Unidad");

        jtxtValor.setText("0");

        jtxtActor.setText("usuario");

        jtxtUnidad.setText("PD");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 354, Short.MAX_VALUE)
                    .addComponent(jrbtnAccionSistema)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addComponent(jLabel6)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jtxtValor, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtUnidad, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                            .addComponent(jrbtnInclusionExtension)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jtxtIE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                            .addComponent(jrbtnAccionActor)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(jtxtActor, javax.swing.GroupLayout.PREFERRED_SIZE, 210, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jrbtnAccionSistema)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jrbtnAccionActor)
                    .addComponent(jtxtActor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jrbtnInclusionExtension)
                    .addComponent(jtxtIE, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtValor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8)
                    .addComponent(jtxtUnidad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jtabComentarios.addTab("Acción", jPanel2);

        jLabel3.setText("Comentarios");

        jtxaComentarios.setColumns(20);
        jtxaComentarios.setRows(5);
        jtxaComentarios.setText("Ninguno");
        jScrollPane2.setViewportView(jtxaComentarios);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 306, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addContainerGap(45, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 151, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(35, Short.MAX_VALUE))
        );

        jtabComentarios.addTab("Comentarios", jPanel3);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jtabComentarios, javax.swing.GroupLayout.DEFAULT_SIZE, 379, Short.MAX_VALUE)
                .addGap(35, 35, 35)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 79, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jbtnAceptar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jbtnCancelar))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addComponent(jtabComentarios, javax.swing.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * editarPropiedades Método que edita las propiedades de un paso
     * @param Ps paso para editar
     */
    public void editarPropiedades(PasoCU Ps) {
        editar = true;
        auxEx = Ps.getExcepcionCU();
        jtxtId.setText(Ps.getIdent());
        jtxaCondicion.setText(Ps.getCondicion());
        jcbcondicional.setSelected(Ps.getEsCondicional());
        jrbtnAccionSistema.setSelected(Ps.getAccionSistema());
        jrbtnAccionActor.setSelected(Ps.getAccionActor());
        jrbtnInclusionExtension.setSelected(Ps.getInclusionExtension());
        jtxtActor.setText(Ps.getActor());
        jtxtIE.setText(Ps.getIE());
        jtxaAccion.setText(Ps.getAccion());
        jtxtValor.setText(String.valueOf(Ps.getValor()));
        jtxtUnidad.setText(Ps.getUnidad());
        jtxaComentarios.setText(Ps.getComentarios());
    }

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            int cont = auxCaso.getLIdentPS().size();
            i = auxCaso.getPasoCU().size();
            if (i == cont) {
                i = i + 1;
                auxCaso.getLIdentPS().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxCaso.getLIdentPS().get(l) == 0) {
                        i = l + 1;
                        auxCaso.getLIdentPS().set(l, 1);
                    }
                }
            }
            newPaso = auxCaso.nuevoPaso(i, auxCaso.getIdent(), jcbcondicional.isSelected(), jtxaCondicion.getText(), jrbtnAccionSistema.isSelected(), jrbtnAccionActor.isSelected(), jrbtnInclusionExtension.isSelected(), jtxtActor.getText(), jtxtIE.getText(), jtxaAccion.getText(), Integer.parseInt(jtxtValor.getText()), jtxtUnidad.getText(), jtxaComentarios.getText());
            MutableTreeNode node = new DefaultMutableTreeNode(newPaso.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Paso");
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxCaso.getPasoCU().size() && encontrado == false) {
                if (auxCaso.getPasoCU().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxCaso.getPasoCU().remove(i);
                    newPaso = auxCaso.nuevoPaso(j+1, auxCaso.getIdent(), jcbcondicional.isSelected(), jtxaCondicion.getText(), jrbtnAccionSistema.isSelected(), jrbtnAccionActor.isSelected(), jrbtnInclusionExtension.isSelected(), jtxtActor.getText(), jtxtIE.getText(), jtxaAccion.getText(), Integer.parseInt(jtxtValor.getText()), jtxtUnidad.getText(), jtxaComentarios.getText());
                    auxCaso.getPasoCU().get(i).setExcepcionCU(auxEx);
                }
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado el Paso");
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmPaso().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JCheckBox jcbcondicional;
    private javax.swing.ButtonGroup jgrpbtnTipoAccion;
    private javax.swing.JRadioButton jrbtnAccionActor;
    private javax.swing.JRadioButton jrbtnAccionSistema;
    private javax.swing.JRadioButton jrbtnInclusionExtension;
    private javax.swing.JTabbedPane jtabComentarios;
    private javax.swing.JTextArea jtxaAccion;
    private javax.swing.JTextArea jtxaComentarios;
    private javax.swing.JTextArea jtxaCondicion;
    private javax.swing.JTextField jtxtActor;
    private javax.swing.JTextField jtxtIE;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtUnidad;
    private javax.swing.JTextField jtxtValor;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
        JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
    }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxaCondicion.setText(String.valueOf(newPaso.getCondicion()));
        jcbcondicional.setSelected(newPaso.getEsCondicional());
        jrbtnAccionSistema.setSelected(newPaso.getAccionSistema());
        jrbtnAccionActor.setSelected(newPaso.getAccionActor());
        jtxtActor.setText(String.valueOf(newPaso.getActor()));
        jrbtnInclusionExtension.setSelected(newPaso.getInclusionExtension());
        jtxtIE.setText(String.valueOf(newPaso.getIE()));
        jtxaAccion.setText(String.valueOf(newPaso.getAccion()));
        jtxtValor.setText(String.valueOf(newPaso.getValor()));
        jtxtUnidad.setText(String.valueOf(newPaso.getUnidad()));
        jtxaComentarios.setText(String.valueOf(newPaso.getComentarios()));
    }
}
