/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jfrmReqRestriccion.java
 *
 * Created on 13-dic-2011, 23:22:19
 */

package vista;

import imagenes.RendererArbol;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import modelo.DocumentoReq;
import modelo.Reunion;

/**
 * jfrmReunion es el formulario con el cual podremos insertar todas las variables de la reunion
 */
public class jfrmReunion extends javax.swing.JFrame implements Observer {
    DocumentoReq auxDocPpal;
    jfrmPrincipal jfaux;
    Reunion newRe;
    MutableTreeNode auxinsertNode;
    int auxinsertIndex;
    private int insertIndex;
    private boolean editar=false;
    MutableTreeNode parent;
    int insertIndex2;

    /**
     * Constructor de JFrame Reunion
     * @param jf es el formulario principal
     * @param docPpal es el documento donde se guardan todas las variables
     * @param insertNode el nodo a insertar
     * @param insertIndex el indice del nodo a insertar
     */
    public jfrmReunion(jfrmPrincipal jf,DocumentoReq docPpal, MutableTreeNode insertNode, int insertIndex) {
        auxinsertNode=insertNode;
        auxinsertIndex=insertIndex;
        jfaux=jf;
        auxDocPpal=docPpal;
        this.setIconImage(new ImageIcon("src/imagenes/reunion.jpg").getImage());
        initComponents();
        int l = 0, i=0;
        int cont = auxDocPpal.getLIdentRE().size();
        i = auxDocPpal.getReunion().size();
        if (i == cont) {
            i = i + 1;
        } else {
            for (l = 0; l < cont; l++) {
                if (auxDocPpal.getLIdentRE().get(l) == 0) {
                    i = l + 1;
                }
            }
        }
        String ident;
        ident ="REU"+String.valueOf(i);
        jtxtId.setText(ident);
    }

    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabReunion = new javax.swing.JTabbedPane();
        jpanGeneral = new javax.swing.JPanel();
        jlbLugar = new javax.swing.JLabel();
        jlbFechaHora = new javax.swing.JLabel();
        jtxtLugar = new javax.swing.JTextField();
        jlbAsistentes = new javax.swing.JLabel();
        jlbNombre = new javax.swing.JLabel();
        jtxtNombre = new javax.swing.JTextField();
        jSpFecha = new javax.swing.JSpinner();
        jScrollPane2 = new javax.swing.JScrollPane();
        jtxaAsistentes = new javax.swing.JTextArea();
        jtxtId = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jpanResultados = new javax.swing.JPanel();
        jlbResultados = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtxaResultados = new javax.swing.JTextArea();
        jbtnAceptar = new javax.swing.JButton();
        jbtnCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Reunion");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jlbLugar.setText("Lugar");

        jlbFechaHora.setText("Fecha y hora:");

        jlbAsistentes.setText("Asistentes");

        jlbNombre.setText("Nombre");

        jSpFecha.setModel(new javax.swing.SpinnerDateModel());

        jtxaAsistentes.setColumns(20);
        jtxaAsistentes.setRows(5);
        jScrollPane2.setViewportView(jtxaAsistentes);

        jtxtId.setEditable(false);

        jLabel14.setText("Identificador:");

        javax.swing.GroupLayout jpanGeneralLayout = new javax.swing.GroupLayout(jpanGeneral);
        jpanGeneral.setLayout(jpanGeneralLayout);
        jpanGeneralLayout.setHorizontalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbNombre)
                                .addGap(10, 10, 10)
                                .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jpanGeneralLayout.createSequentialGroup()
                                .addComponent(jlbLugar)
                                .addGap(20, 20, 20)
                                .addComponent(jtxtLugar, javax.swing.GroupLayout.PREFERRED_SIZE, 278, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap(98, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 65, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jtxtId, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(256, 256, 256))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbFechaHora)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSpFecha, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(252, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jlbAsistentes)
                        .addContainerGap(373, Short.MAX_VALUE))
                    .addGroup(jpanGeneralLayout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 296, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(127, Short.MAX_VALUE))))
        );
        jpanGeneralLayout.setVerticalGroup(
            jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanGeneralLayout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jtxtId)
                    .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jtxtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbNombre))
                .addGap(18, 18, 18)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jtxtLugar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbLugar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jpanGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbFechaHora)
                    .addComponent(jSpFecha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jlbAsistentes)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(80, 80, 80))
        );

        jTabReunion.addTab("General", jpanGeneral);

        jlbResultados.setText("Resultados");

        jtxaResultados.setColumns(20);
        jtxaResultados.setRows(5);
        jtxaResultados.setText("PD");
        jScrollPane1.setViewportView(jtxaResultados);

        javax.swing.GroupLayout jpanResultadosLayout = new javax.swing.GroupLayout(jpanResultados);
        jpanResultados.setLayout(jpanResultadosLayout);
        jpanResultadosLayout.setHorizontalGroup(
            jpanResultadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanResultadosLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jpanResultadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 395, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jlbResultados))
                .addContainerGap(18, Short.MAX_VALUE))
        );
        jpanResultadosLayout.setVerticalGroup(
            jpanResultadosLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanResultadosLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jlbResultados)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(17, Short.MAX_VALUE))
        );

        jTabReunion.addTab("Resultados", jpanResultados);

        jbtnAceptar.setText("Aceptar");
        jbtnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAceptarActionPerformed(evt);
            }
        });

        jbtnCancelar.setText("Cancelar");
        jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabReunion, javax.swing.GroupLayout.PREFERRED_SIZE, 438, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jbtnAceptar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jbtnCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabReunion, javax.swing.GroupLayout.PREFERRED_SIZE, 292, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jbtnAceptar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jbtnCancelar)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * jbtnCancelarActionPerformed Activa el boton cancelar
     * @param evt
     */
    private void jbtnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCancelarActionPerformed
        jfaux.LeeArbol();
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_jbtnCancelarActionPerformed

    /**
     * formWindowClosed es el metodo que se activa cuando pulsamos la x de cerrar
     * @param evt
     */
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        jfaux.setEnabled(true);
        this.dispose();
    }//GEN-LAST:event_formWindowClosed

    /**
     * editarPropiedades Método que edita las propiedades de una reunion
     * @param Reu reunion para editar
     */
    void editarPropiedades(Reunion Reu) {
        editar = true;
        jtxtId.setText(Reu.getIdent());
        jtxtNombre.setText(Reu.getNombre());
        jtxtLugar.setText(Reu.getLugar());
        jSpFecha.setToolTipText(Reu.getFecha());
        jtxaAsistentes.setText(Reu.getAsistentes());
        jtxaResultados.setText(Reu.getResultados());
    }

    /**
     * jbtnAceptarActionPerformed Activa el boton aceptar
     * @param evt
     */
    private void jbtnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAceptarActionPerformed
        String ident;
        int i, j=0, l=0;
        ident=jtxtId.getText();
        if (!editar) {
            int cont = auxDocPpal.getLIdentRE().size();
            i = auxDocPpal.getReunion().size();
            if (i == cont) {
                i = i + 1;
                auxDocPpal.getLIdentRE().add(1);
            } else {
                for (l = 0; l < cont; l++) {
                    if (auxDocPpal.getLIdentRE().get(l) == 0) {
                        i = l + 1;
                        auxDocPpal.getLIdentRE().set(l, 1);
                    }
                }
            }
            newRe = auxDocPpal.NuevoReu(i, jtxtNombre.getText(), jtxtLugar.getText(), jSpFecha.getModel().getValue().toString(), jtxaAsistentes.getText(), jtxaResultados.getText());
            MutableTreeNode node = new DefaultMutableTreeNode(newRe.getIdent());
            DefaultTreeModel model = (DefaultTreeModel) jfaux.getJtreDocumento().getModel();
            model.insertNodeInto(node, auxinsertNode, auxinsertIndex);
            jfaux.getJtreDocumento().setCellRenderer(new RendererArbol());
            jfaux.LeeArbol();
            mostrarmensaje("Insertado la reunion " + newRe.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        } else {
            boolean encontrado = false;
            i = 0;
            while (i < auxDocPpal.getReunion().size() && encontrado == false) {
                if (auxDocPpal.getReunion().get(i).getIdent().equals(ident)) {
                    encontrado = true;
                    j = i;
                    auxDocPpal.getReunion().remove(i);
                    newRe = auxDocPpal.NuevoReu(j+1, jtxtNombre.getText(), jtxtLugar.getText(), jSpFecha.getToolTipText(), jtxaAsistentes.getText(), jtxaResultados.getText());
                }
                i++;
            }
            jfaux.LeeArbol();
            mostrarmensaje("Insertado la reunion " + newRe.getNombre());
            jfaux.setEnabled(true);
            this.dispose();
        }
    }//GEN-LAST:event_jbtnAceptarActionPerformed

    /**
    * @param args the command line arguments
    */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    public void run() {
    new jfrmReqInformacion().setVisible(true);
    }
    });
    }*/

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel14;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSpinner jSpFecha;
    private javax.swing.JTabbedPane jTabReunion;
    private javax.swing.JButton jbtnAceptar;
    private javax.swing.JButton jbtnCancelar;
    private javax.swing.JLabel jlbAsistentes;
    private javax.swing.JLabel jlbFechaHora;
    private javax.swing.JLabel jlbLugar;
    private javax.swing.JLabel jlbNombre;
    private javax.swing.JLabel jlbResultados;
    private javax.swing.JPanel jpanGeneral;
    private javax.swing.JPanel jpanResultados;
    private javax.swing.JTextArea jtxaAsistentes;
    private javax.swing.JTextArea jtxaResultados;
    private javax.swing.JTextField jtxtId;
    private javax.swing.JTextField jtxtLugar;
    private javax.swing.JTextField jtxtNombre;
    // End of variables declaration//GEN-END:variables

    /**
     * Muestra un mensaje en un JOptionPane
     * @param mensaje a mostrar en el JOptionPane
     */
    private void mostrarmensaje(String mensaje) {
         JOptionPane.showMessageDialog(this, mensaje, "Advertencia",
                                JOptionPane.WARNING_MESSAGE);
        }

    /**
     * update Método que es llamado cuando el objeto observado cambia
     * @param o objeto observable
     * @param arg argumento pasado al método notifyObservers
     */
    public void update(Observable o, Object arg) {
        jtxtNombre.setText(String.valueOf(newRe.getNombre()));
        jtxtLugar.setText(String.valueOf(newRe.getLugar()));
        jSpFecha.setToolTipText(String.valueOf(newRe.getFecha()));
        jtxaAsistentes.setText(String.valueOf(newRe.getAsistentes()));
        jtxaResultados.setText(String.valueOf(newRe.getResultados()));
    }
}
